// #define _WIN32_WINNT 0x0500

#if (defined _WIN32)
#include <windows.h>
#endif

#ifdef __GNUC__
#define __fastcall __attribute__((fastcall))
#endif

unsigned __fastcall WalkSum(unsigned *p, unsigned num)
{
  unsigned b = 0;
  unsigned j;
  for(j = 0; j < num; j += 16)
  {
    b = b + p[j] +
      p[j + 1] +
      p[j + 2] +
      p[j + 3] +
      p[j + 4] +
      p[j + 5] +
      p[j + 6] +
      p[j + 7] +
      p[j + 8] +
      p[j + 9] +
      p[j + 10] +
      p[j + 11] +
      p[j + 12] +
      p[j + 13] +
      p[j + 14] +
      p[j + 15];
  }
  return b;
}

unsigned __fastcall WalkSum2(unsigned *p, unsigned num, unsigned step)
{
  unsigned b = 0;
  unsigned j;
  for(j = 0; j < num; j += step)
    b += p[j];
  return b;
}

void __fastcall WalkWrite(unsigned *p, unsigned num)
{
  unsigned j;
  for(j = 0; j < num; j += 8)
  {
    p[j] = 0;
    p[j + 1] = 0;
    p[j + 2] = 0;
    p[j + 3] = 0;
    p[j + 4] = 0;
    p[j + 5] = 0;
    p[j + 6] = 0;
    p[j + 7] = 0;
  }
}

void __fastcall WalkWrite2(unsigned *p, unsigned num, unsigned step)
{
  unsigned j;
  unsigned step2 = step * 2;
  for(j = 0; j < num; j += step2)
  {
    p[j] = 0;
    p[j + step] = 0;
  }
}

unsigned __fastcall Walk1Add(unsigned *p, unsigned num, unsigned a0)
{
  unsigned b = a0;
  const unsigned num2 = num >> 4;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
    b += p[b];
  }
  return b;
}

unsigned __fastcall Walk1Nop(unsigned *p, unsigned num, unsigned a0)
{
  unsigned b = a0;
  unsigned k = (a0 < 0xFFFFFFFF) ? 0 : 1;
  unsigned j;
  for(j = 0; j < num; j++)
  {
    b += k;
    b = p[b];
  }
  return b;
}

unsigned __fastcall Walk1(unsigned *p, unsigned num, unsigned a0)
{
  unsigned b = a0;
  const unsigned num2 = num >> 4;
  unsigned j;
  for(j = 0; j < num2; j++)
    b = p[p[p[p[p[p[p[p[p[p[p[p[p[p[p[p[b]]]]]]]]]]]]]]]];
  return b;
}


#define A1    a0 = p[a0];
#define A2 A1 a1 = p[a1];
#define A3 A2 a2 = p[a2];
#define A4 A3 a3 = p[a3];
#define A5 A4 a4 = p[a4];
#define A6 A5 a5 = p[a5];
#define A7 A6 a6 = p[a6];
#define A8 A7 a7 = p[a7];
#define A9 A8 a8 = p[a8];

unsigned __fastcall Walk2(unsigned *p, unsigned num, unsigned a0, unsigned a1)
{
  const unsigned num2 = num >> 2;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A2; A2; A2; A2;
  }
  return a0 + a1;
}

unsigned __fastcall Walk3(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A3; A3;
  }
  return a0 + a1 + a2;
}

unsigned __fastcall Walk4(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A4; A4;
  }
  return a0 + a1 + a2 + a3;
}

unsigned __fastcall Walk5(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A5; A5;
  }
  return a0 + a1 + a2 + a3 + a4;
}

unsigned __fastcall Walk6(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4, unsigned a5)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A6; A6;
  }
  return a0 + a1 + a2 + a3 + a4 + a5;
}

unsigned __fastcall Walk7(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4, unsigned a5, unsigned a6)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A7; A7;
  }
  return a0 + a1 + a2 + a3 + a4 + a5 + a6;
}

unsigned __fastcall Walk8(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4, unsigned a5, unsigned a6, unsigned a7)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A8; A8;
  }
  return a0 + a1 + a2 + a3 + a4 + a5 + a6 + a7;
}

unsigned __fastcall Walk9(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4, unsigned a5, unsigned a6, unsigned a7, unsigned a8)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    A9; A9;
  }
  return a0 + a1 + a2 + a3 + a4 + a5 + a6 + a7 + a8;
}


#define D1    a0 = *a0;
#define D2 D1 a1 = *a1;
#define D3 D2 a2 = *a2;
#define D4 D3 a3 = *a3;
#define D5 D4 a4 = *a4;
#define D6 D5 a5 = *a5;
#define D7 D6 a6 = *a6;
#define D8 D7 a7 = *a7;
#define D9 D8 a8 = *a8;

unsigned int __fastcall Walk1d(unsigned int num, void **a0)
{
  const unsigned int num2 = num >> 4;
  unsigned int j;
  for(j = 0; j < num2; j++)
    a0 = *(void **)*(void **)*(void **)*(void **)
        *(void **)*(void **)*(void **)*(void **)
        *(void **)*(void **)*(void **)*(void **)
        *(void **)*(void **)*(void **)*a0;
  return (int)a0;
}

unsigned int __fastcall Walk2d(unsigned int num, void **a0, void **a1)
{
  const unsigned int num2 = num >> 3;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    D2; D2; D2; D2;
    D2; D2; D2; D2;
  }
  return (int)a0 + (int)a1;
}

unsigned int __fastcall Walk3d(unsigned int num, void **a0, void **a1, void **a2)
{
  const unsigned int num2 = num >> 3;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    D3; D3; D3; D3;
    D3; D3; D3; D3;
  }
  return (int)a0 + (int)a1 + (int)a2;
}

unsigned int __fastcall Walk4d(unsigned int num, void **a0, void **a1, void **a2, void **a3)
{
  const unsigned int num2 = num >> 3;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    D4; D4; D4; D4;
    D4; D4; D4; D4;
  }
  return (int)a0 + (int)a1 + (int)a2 + (int)a3;
}

unsigned int __fastcall Walk5d(unsigned int num, void **a0, void **a1, void **a2, void **a3, void **a4)
{
  const unsigned int num2 = num >> 3;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    D5; D5; D5; D5;
    D5; D5; D5; D5;
  }
  return (int)a0 + (int)a1 + (int)a2 + (int)a3 + (int)a4;
}

unsigned int __fastcall Walk6d(unsigned int num, void **a0, void **a1, void **a2, void **a3, void **a4, void **a5)
{
  const unsigned int num2 = num >> 3;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    D6; D6; D6; D6;
    D6; D6; D6; D6;
  }
  return (int)a0 + (int)a1 + (int)a2 + (int)a3 + (int)a4 + (int)a5;
}

#define PPP(x, y) y = p[x]; p[x] = y;

#define B1     PPP(a0, z0)
#define B2  B1 PPP(a1, z1)
#define B3  B2 PPP(a2, z2)
#define B4  B3 PPP(a3, z3)
#define B5  B4 PPP(a4, z4)
#define B6  B5 PPP(a5, z5)

#define C1     PPP(z0, a0)
#define C2  C1 PPP(z1, a1)
#define C3  C2 PPP(z2, a2)
#define C4  C3 PPP(z3, a3)
#define C5  C4 PPP(z4, a4)
#define C6  C5 PPP(z5, a5)

unsigned __fastcall Walk1w(unsigned *p, unsigned num, unsigned a0)
{
  const unsigned num2 = num >> 3;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0;
    B1; C1;
    B1; C1;
    B1; C1;
    B1; C1;
  }
  return a0;
}

unsigned __fastcall Walk2w(unsigned *p, unsigned num, unsigned a0, unsigned a1)
{
  const unsigned num2 = num >> 3;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0, z1;
    B2; C2;
    B2; C2;
    B2; C2;
    B2; C2;
  }
  return a0 + a1;
}

unsigned __fastcall Walk3w(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2)
{
  const unsigned num2 = num >> 3;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0, z1, z2;
    B3; C3;
    B3; C3;
    B3; C3;
    B3; C3;
  }
  return a0 + a1 + a2;
}

unsigned __fastcall Walk4w(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3)
{
  const unsigned num2 = num >> 3;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0, z1, z2, z3;
    B4; C4;
    B4; C4;
    B4; C4;
    B4; C4;
  }
  return a0 + a1 + a2 + a3;
}

unsigned __fastcall Walk5w(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0, z1, z2, z3, z4;
    B5; C5;
  }
  return a0 + a1 + a2 + a3 + a4;
}

unsigned __fastcall Walk6w(unsigned *p, unsigned num, unsigned a0, unsigned a1, unsigned a2, unsigned a3, unsigned a4, unsigned a5)
{
  const unsigned num2 = num >> 1;
  unsigned j;
  for(j = 0; j < num2; j++)
  {
    unsigned z0, z1, z2, z3, z4, z5;
    B6; C6;
  }
  return a0 + a1 + a2 + a3 + a4 + a5;
}


#define MMM(x, y) y = *x; *x = y;

#define E1     MMM(a0, z0)
#define E2  E1 MMM(a1, z1)
#define E3  E2 MMM(a2, z2)

#define F1     MMM(z0, a0)
#define F2  F1 MMM(z1, a1)
#define F3  F2 MMM(z2, a2)

unsigned int __fastcall Walk1wd(unsigned int num, void **a0)
{
  const unsigned int num2 = num >> 1;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    void **z0;
    E1; F1;
  }
  return (int)a0;
}

unsigned int __fastcall Walk2wd(unsigned int num, void **a0, void **a1)
{
  const unsigned int num2 = num >> 1;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    void **z0, **z1;
    E2; F2;
  }
  return (int)a0 + (int)a1;
}

unsigned int __fastcall Walk3wd(unsigned int num, void **a0, void **a1, void **a2)
{
  const unsigned int num2 = num >> 1;
  unsigned int j;
  for(j = 0; j < num2; j++)
  {
    void **z0, **z1, **z2;
    E3; F3;
  }
  return (int)a0 + (int)a1 + (int)a2;
}
